/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : Cpu.c
**     Project     : ProcessorExpert
**     Processor   : MCF51JM128VLH
**     Component   : MCF51JM128_64
**     Version     : Component 01.010, Driver 01.12, CPU db: 3.00.063
**     Datasheet   : MCF51JM128RM Rev. 2 6/2009
**     Compiler    : CodeWarrior ColdFireV1 C Compiler
**     Date/Time   : 2012-11-14, 07:43, # CodeGen: 15
**     Abstract    :
**         This component "MCF51JM128_64" contains initialization of the
**         CPU and provides basic methods and events for CPU core
**         settings.
**     Settings    :
**
**     Contents    :
**         EnableInt  - void Cpu_EnableInt(void);
**         DisableInt - void Cpu_DisableInt(void);
**         Delay100US - void Cpu_Delay100US(word us100);
**
**     Copyright : 1997 - 2012 Freescale, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE Cpu. */
#include "USB1.h"
#include "USBInit1.h"
#include "CDC1.h"
#include "Tx1.h"
#include "Rx1.h"
#include "WAIT1.h"
#include "LED1.h"
#include "LEDpin1.h"
#include "LED2.h"
#include "LEDpin2.h"
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Events.h"
#include "Cpu.h"

/* Global variables */
volatile far word SR_reg;              /* Current CCR register */
volatile byte SR_lock;


/*
** ===================================================================
**     Method      :  Cpu_Cpu_Interrupt (component MCF51JM128_64)
**
**     Description :
**         This ISR services an unused interrupt/exception vector.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
ISR(Cpu_Interrupt)
{
  /* This code can be changed using the CPU component property "Build Options / Unhandled int code" */
  /* asm (HALT) */
}


/*
** ===================================================================
**     Method      :  Cpu_Delay100US (component MCF51JM128_64)
**
**     Description :
**         This method realizes software delay. The length of delay is
**         at least 100 microsecond multiply input parameter [us100].
**         As the delay implementation is not based on real clock, the
**         delay time may be increased by interrupt service routines
**         processed during the delay. The method is independent on
**         selected speed mode.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us100           - Number of 100 us delay repetitions.
**     Returns     : Nothing
** ===================================================================
*/
#pragma aligncode on

__declspec(register_abi) void Cpu_Delay100US(word us100:__D0)
{
  /* irremovable one time overhead (ignored): 11 cycles */
  /* move: 1 cycle overhead (load parameter into register) */
  /* jsr:  3 cycles overhead (jump to subroutine) */
  /* andi: 1 cycle overhead (clear upper word of d0) */
  /* tpf: 1 cycle overhead (alignment) */
  /* rts:  5 cycles overhead (return from subroutine) */

  /* aproximate irremovable overhead for each 100us cycle (counted) : 3 cycles */
  /* subq.l 1 cycles overhead  */
  /* bne.b  2 cycles overhead  */

  /* Disable MISRA rule 55 checking - Non-case label used */
  /*lint -esym( 961, 55)   */
#pragma unused(us100)
  asm {
    naked
    andi.l #0xFFFF,d0                  /* parameter is word - clear the rest of d0 register */
    tpf                                /* alignment */
loop:
    /* 100 us delay block begin */
    /*
     * Delay
     *   - requested                  : 100 us @ 24MHz,
     *   - possible                   : 2400 c, 100000 ns
     *   - without removable overhead : 2397 c, 99875 ns
     */
    move.l #0x031E,d1                  /* (1 c: 41.67 ns) number of iterations */
label0:
    subq.l #1,d1                       /* (1 c: 41.67 ns) decrement d1 */
    bne.b label0                       /* (2 c: 83.33 ns) repeat 798x */
    tpf                                /* (1 c: 41.67 ns) wait for 1 c */
    /* 100 us delay block end */
    subq.l #1,d0                       /* parameter is passed via d0 register */
    bne.w loop                         /* next loop */
    rts                                /* return from subroutine */
  }
  /* Restore MISRA rule 55 checking - Non-case label used */
  /*lint +esym( 961, 55)   */
}

/*
** ===================================================================
**     Method      :  Cpu_DisableInt (component MCF51JM128_64)
**
**     Description :
**         Disables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (component MCF51JM128_64)
**
**     Description :
**         Enables maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  __initialize_hardware (component MCF51JM128_64)
**
**     Description :
**         Configure the basic system functions (timing, etc.).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/*** !!! Here you can place your own code using property "User data declarations" on the build options tab of the CPU component. !!! ***/


void __initialize_hardware(void)
{

  /*** !!! Here you can place your own code using property "User code before PE initialization" on the build options tab of the CPU component. !!! ***/

  /* ### MCF51JM128_64 "Cpu" init code ... */
  /*  PE initialization code after reset */
  /* Common initialization of the write once registers */
  /* SOPT1: COPT=0,STOPE=0,WAITE=1,??=0,??=0,??=0,??=0 */
  setReg8(SOPT1, 0x10U);                
  /* SOPT2: COPCLKS=0,COPW=0,USB_BIGEND=1,CLKOUT_EN=0,CMT_CLK_SEL=0,SPI1FE=1,SPI2FE=1,ACIC=0 */
  setReg8(SOPT2, 0x26U);                
  /* SPMSC1: LVWF=0,LVWACK=0,LVWIE=0,LVDRE=1,LVDSE=1,LVDE=1,??=0,BGBE=0 */
  setReg8(SPMSC1, 0x1CU);               
  /* SPMSC2: ??=0,??=0,LVDV=0,LVWV=0,PPDF=0,PPDACK=0,??=0,PPDC=0 */
  setReg8(SPMSC2, 0x00U);               
  /* Initialization of CPU registers */
  /*lint -save  -e950 Disable MISRA rule (1.1) checking. */
  asm {
    /* VBR: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,ADDRESS=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0 */
    clr.l d0
    movec d0,VBR
    /* CPUCR: ARD=0,IRD=0,IAE=0,IME=0,BWD=0,??=0,FSD=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0 */
    clr.l d0
    movec d0,CPUCR
  }
  /*lint -restore Enable MISRA rule (1.1) checking. */
  /*  System clock initialization */
  /*lint -save  -e923 Disable MISRA rule (11.3) checking. */
  if (*(unsigned char*)0x03FFU != 0xFFU) { /* Test if the device trim value is stored on the specified address */
    MCGTRM = *(unsigned char*)0x03FFU; /* Initialize MCGTRM register from a non volatile memory */
    MCGSC = *(unsigned char*)0x03FEU;  /* Initialize MCGSC register from a non volatile memory */
  }
  /*lint -restore Enable MISRA rule (11.3) checking. */
  /* MCGC2: BDIV=0,RANGE=1,HGO=1,LP=0,EREFS=1,ERCLKEN=1,EREFSTEN=0 */
  setReg8(MCGC2, 0x36U);               /* Set MCGC2 register */ 
  while(MCGSC_OSCINIT == 0U) {         /* Wait until external reference is stable */
  }
  /* MCGC3: DIV32=1 */
  setReg8Bits(MCGC3, 0x10U);            
  /* MCGC1: CLKS=2,RDIV=3,IREFS=0,IRCLKEN=1,IREFSTEN=0 */
  setReg8(MCGC1, 0x9AU);               /* Set MCGC1 register */ 
  while(MCGSC_IREFST != 0U) {          /* Wait until external reference is selected */
  }
  /* MCGC3: LOLIE=0,PLLS=0,CME=0,DIV32=1,VDIV=8 */
  setReg8(MCGC3, 0x18U);               /* Set MCGC3 register */ 
  /* MCGC4: ??=0,??=0,DMX32=0,??=0,??=0,??=0,DRST_DRS=0 */
  setReg8(MCGC4, 0x00U);               /* Set MCGC4 register */ 
  while((MCGSC & 0x0CU) != 0x08U) {    /* Wait until external clock is selected as a bus clock reference */
  }
  /* MCGC2: BDIV=0,RANGE=1,HGO=1,LP=1,EREFS=1,ERCLKEN=1,EREFSTEN=0 */
  setReg8(MCGC2, 0x3EU);               /* Set MCGC2 register */ 
  /* MCGC1: CLKS=2,RDIV=3,IREFS=0,IRCLKEN=1,IREFSTEN=0 */
  setReg8(MCGC1, 0x9AU);               /* Set MCGC1 register */ 
  /* MCGC3: LOLIE=0,PLLS=0,CME=0,DIV32=0,VDIV=8 */
  setReg8(MCGC3, 0x08U);               /* Set MCGC3 register */ 
  /* MCGC3: LOLIE=0,PLLS=1,CME=0,DIV32=0,VDIV=8 */
  setReg8(MCGC3, 0x48U);               /* Set MCGC3 register */ 
  while(MCGSC_PLLST == 0U) {           /* Wait until PLL is selected */
  }
  /* MCGC2: LP=0 */
  clrReg8Bits(MCGC2, 0x08U);            
  while(MCGSC_LOCK == 0U) {            /* Wait until PLL is locked */
  }
  /* MCGC1: CLKS=0,RDIV=3,IREFS=0,IRCLKEN=1,IREFSTEN=0 */
  setReg8(MCGC1, 0x1AU);               /* Set MCGC1 register */ 
  while((MCGSC & 0x0CU) != 0x0CU) {    /* Wait until PLL clock is selected as a bus clock reference */
  }
  

  /*** End of PE initialization code after reset ***/

  /*** !!! Here you can place your own code using property "User code after PE initialization" on the build options tab of the CPU component. !!! ***/

}

/*
** ===================================================================
**     Method      :  PE_low_level_init (component MCF51JM128_64)
**
**     Description :
**         Initializes components and provides common register 
**         initialization. The method is called automatically as a part 
**         of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  /* SCGC1: CMT=1,TPM2=1,TPM1=1,ADC=1,IIC2=1,IIC1=1,SCI2=1,SCI1=1 */
  setReg8(SCGC1, 0xFFU);                
  /* SCGC2: USB=1,FLS=1,IRQ=1,KBI=1,ACMP=1,RTC=1,SPI2=1,SPI1=1 */
  setReg8(SCGC2, 0xFFU);                
  /* SCGC3: ??=1,??=1,??=1,??=1,??=1,??=1,??=1,RNGA=1 */
  setReg8(SCGC3, 0xFFU);                
  /* Common initialization of the CPU registers */
  /* PTED: PTED3=0,PTED2=0 */
  clrReg8Bits(PTED, 0x0CU);             
  /* PTEPE: PTEPE3=0,PTEPE2=0 */
  clrReg8Bits(PTEPE, 0x0CU);            
  /* PTEDD: PTEDD3=1,PTEDD2=1 */
  setReg8Bits(PTEDD, 0x0CU);            
  /* PTASE: PTASE5=0,PTASE4=0,PTASE3=0,PTASE2=0,PTASE1=0,PTASE0=0 */
  clrReg8Bits(PTASE, 0x3FU);            
  /* PTBSE: PTBSE7=0,PTBSE6=0,PTBSE5=0,PTBSE4=0,PTBSE3=0,PTBSE2=0,PTBSE1=0,PTBSE0=0 */
  setReg8(PTBSE, 0x00U);                
  /* PTCSE: PTCSE6=0,PTCSE5=0,PTCSE4=0,PTCSE3=0,PTCSE2=0,PTCSE1=0,PTCSE0=0 */
  clrReg8Bits(PTCSE, 0x7FU);            
  /* PTDSE: PTDSE7=0,PTDSE6=0,PTDSE5=0,PTDSE4=0,PTDSE3=0,PTDSE2=0,PTDSE1=0,PTDSE0=0 */
  setReg8(PTDSE, 0x00U);                
  /* PTESE: PTESE7=0,PTESE6=0,PTESE5=0,PTESE4=0,PTESE3=0,PTESE2=0,PTESE1=0,PTESE0=0 */
  setReg8(PTESE, 0x00U);                
  /* PTFSE: PTFSE7=0,PTFSE6=0,PTFSE5=0,PTFSE4=0,PTFSE3=0,PTFSE2=0,PTFSE1=0,PTFSE0=0 */
  setReg8(PTFSE, 0x00U);                
  /* PTGSE: PTGSE5=0,PTGSE4=0,PTGSE3=0,PTGSE2=0,PTGSE1=0,PTGSE0=0 */
  clrReg8Bits(PTGSE, 0x3FU);            
  /* PTADS: PTADS7=0,PTADS6=0,PTADS5=1,PTADS4=1,PTADS3=1,PTADS2=1,PTADS1=1,PTADS0=1 */
  setReg8(PTADS, 0x3FU);                
  /* PTBDS: PTBDS7=1,PTBDS6=1,PTBDS5=1,PTBDS4=1,PTBDS3=1,PTBDS2=1,PTBDS1=1,PTBDS0=1 */
  setReg8(PTBDS, 0xFFU);                
  /* PTCDS: PTCDS7=0,PTCDS6=1,PTCDS5=1,PTCDS4=1,PTCDS3=1,PTCDS2=1,PTCDS1=1,PTCDS0=1 */
  setReg8(PTCDS, 0x7FU);                
  /* PTDDS: PTDDS7=1,PTDDS6=1,PTDDS5=1,PTDDS4=1,PTDDS3=1,PTDDS2=1,PTDDS1=1,PTDDS0=1 */
  setReg8(PTDDS, 0xFFU);                
  /* PTEDS: PTEDS7=1,PTEDS6=1,PTEDS5=1,PTEDS4=1,PTEDS3=1,PTEDS2=1,PTEDS1=1,PTEDS0=1 */
  setReg8(PTEDS, 0xFFU);                
  /* PTFDS: PTFDS7=1,PTFDS6=1,PTFDS5=1,PTFDS4=1,PTFDS3=1,PTFDS2=1,PTFDS1=1,PTFDS0=1 */
  setReg8(PTFDS, 0xFFU);                
  /* PTGDS: PTGDS7=0,PTGDS6=0,PTGDS5=1,PTGDS4=1,PTGDS3=1,PTGDS2=1,PTGDS1=1,PTGDS0=1 */
  setReg8(PTGDS, 0x3FU);                
  /* PTAIFE: PTAIFE5=0,PTAIFE4=0,PTAIFE3=0,PTAIFE2=0,PTAIFE1=0,PTAIFE0=0 */
  clrReg8Bits(PTAIFE, 0x3FU);           
  /* PTBIFE: PTBIFE7=0,PTBIFE6=0,PTBIFE5=0,PTBIFE4=0,PTBIFE3=0,PTBIFE2=0,PTBIFE1=0,PTBIFE0=0 */
  setReg8(PTBIFE, 0x00U);               
  /* PTCIFE: PTCIFE6=0,PTCIFE5=0,PTCIFE4=0,PTCIFE3=0,PTCIFE2=0,PTCIFE1=0,PTCIFE0=0 */
  clrReg8Bits(PTCIFE, 0x7FU);           
  /* PTDIFE: PTDIFE7=0,PTDIFE6=0,PTDIFE5=0,PTDIFE4=0,PTDIFE3=0,PTDIFE2=0,PTDIFE1=0,PTDIFE0=0 */
  setReg8(PTDIFE, 0x00U);               
  /* PTEIFE: PTEIFE7=0,PTEIFE6=0,PTEIFE5=0,PTEIFE4=0,PTEIFE3=0,PTEIFE2=0,PTEIFE1=0,PTEIFE0=0 */
  setReg8(PTEIFE, 0x00U);               
  /* PTFIFE: PTFIFE7=0,PTFIFE6=0,PTFIFE5=0,PTFIFE4=0,PTFIFE3=0,PTFIFE2=0,PTFIFE1=0,PTFIFE0=0 */
  setReg8(PTFIFE, 0x00U);               
  /* PTGIFE: PTGIFE5=0,PTGIFE4=0,PTGIFE3=0,PTGIFE2=0,PTGIFE1=0,PTGIFE0=0 */
  clrReg8Bits(PTGIFE, 0x3FU);           
  /* PTADD: PTADD7=1,PTADD6=1 */
  setReg8Bits(PTADD, 0xC0U);            
  /* PTCDD: PTCDD7=1 */
  setReg8Bits(PTCDD, 0x80U);            
  /* PTGDD: PTGDD7=1,PTGDD6=1 */
  setReg8Bits(PTGDD, 0xC0U);            
  /* PTHDD: PTHDD4=1,PTHDD3=1,PTHDD2=1,PTHDD1=1,PTHDD0=1 */
  setReg8Bits(PTHDD, 0x1FU);            
  /* PTJDD: PTJDD4=1,PTJDD3=1,PTJDD2=1,PTJDD1=1,PTJDD0=1 */
  setReg8Bits(PTJDD, 0x1FU);            
  /* ### Shared modules init code ... */
  /* ### Init_USB_OTG "USBInit1" init code ... */
  USBInit1_Init();
  /* ### RingBufferUInt8 "Tx1" init code ... */
  Tx1_Init();
  /* ### RingBufferUInt8 "Rx1" init code ... */
  Rx1_Init();
  (void)USB1_Init();
  /* ### BitIO "LEDpin1" init code ... */
  /* ### LED "LED1" init code ... */
  LED1_Init(); /* initializes the driver */
  /* ### BitIO "LEDpin2" init code ... */
  /* ### LED "LED2" init code ... */
  LED2_Init(); /* initializes the driver */
  /* INTC_WCR: ENB=1,??=0,??=0,??=0,??=0,MASK=0 */
  setReg8(INTC_WCR, 0x80U);             
  SR_lock = 0x00;
  /* Set initial interrupt priority 0 */
  asm {
    move.w SR,D0;
    andi.l #0xF8FF,D0;
    move.w D0,SR;
  }
}

/* Initialization of the CPU registers in FLASH */
/* NVPROT: FPS6=1,FPS5=1,FPS4=1,FPS3=1,FPS2=1,FPS1=1,FPS0=1,FPOPEN=1 */
static unsigned char NVPROT_INIT @0x0000040D = 0xFFU;
/* NVOPT: KEYEN1=0,KEYEN0=1,??=1,??=1,??=1,??=1,SEC1=1,SEC0=1 */
static unsigned char NVOPT_INIT @0x0000040F = 0x7FU;
/* END Cpu. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale ColdFireV1 series of microcontrollers.
**
** ###################################################################
*/
