/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : WAIT1.c
**     Project     : ProcessorExpert
**     Processor   : MCF51JM128VLH
**     Component   : Wait
**     Version     : Component 01.056, Driver 01.00, CPU db: 3.00.063
**     Compiler    : CodeWarrior ColdFireV1 C Compiler
**     Date/Time   : 2012-11-14, 07:43, # CodeGen: 15
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Wait10Cycles  - void WAIT1_Wait10Cycles(void);
**         Wait100Cycles - void WAIT1_Wait100Cycles(void);
**         WaitCycles    - void WAIT1_WaitCycles(word cycles);
**         Waitms        - void WAIT1_Waitms(word ms);
**         Waitus        - void WAIT1_Waitus(word us);
**         Waitns        - void WAIT1_Waitns(word ns);
**         WaitOSms      - void WAIT1_WaitOSms(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing waiting routines using Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE WAIT1. */

#include "WAIT1.h"

/* tell the compiler not to inline functions in this module, as they are timing critical */
#pragma dont_inline on

/*
** ===================================================================
**     Method      :  WAIT1_Wait10Cycles (component Wait)
**
**     Description :
**         Wait for approximately 10 CPU cycles.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void WAIT1_Wait10Cycles(void)
{
  /* This function will wait 10 CPU cycles (including call overhead). */
  asm {
                                             /* [3] JSR to here on the caller side */
    nop                                      /* [1]  */
    nop                                      /* [1]  */
                                             /* [5] for RTS, return from subroutine */
  }
}

/*
** ===================================================================
**     Method      :  WAIT1_Wait100Cycles (component Wait)
**
**     Description :
**         Wait for 100 CPU cycles.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void WAIT1_Wait100Cycles(void)
{
  /* This function will spend 100 CPU cycles (including call overhead). */
  asm {
                                             /* [3] JSR to here on the caller side */
    move.l #31,d1                            /* [1] number of iterations */
  loop:
    subq.l #1,d1                             /* [1] decrement d1 */
    bne.b loop                               /* [2] repeat 31x=([1]+[2])*31=[93] */
                                             /* [5] return from subroutine */
  }
}
/*
** ===================================================================
**     Method      :  WAIT1_WaitCycles (component Wait)
**
**     Description :
**         Wait for 100 CPU cycles.
**     Parameters  :
**         NAME            - DESCRIPTION
**         cycles          - The number of cycles to wait.
**     Returns     : Nothing
** ===================================================================
*/
void WAIT1_WaitCycles(word cycles)
{
  while(cycles > 100) {
    WAIT1_Wait100Cycles();
    cycles -= 100;
  }
}

/*
** ===================================================================
**     Method      :  WAIT1_Waitms (component Wait)
**
**     Description :
**         Wait for a specified time in milliseconds.
**     Parameters  :
**         NAME            - DESCRIPTION
**         ms              - How many milliseconds the function has to
**                           wait
**     Returns     : Nothing
** ===================================================================
*/
void WAIT1_Waitms(word ms)
{
  if (ms>0) {
    Cpu_Delay100US((word)(ms*10));
  }
}
/*
** ===================================================================
**     Method      :  WAIT1_Waitus (component Wait)
**
**     Description :
**         Wait for a specified time in microseconds.
**     Parameters  :
**         NAME            - DESCRIPTION
**         us              - How many microseconds the function has to
**                           wait
**     Returns     : Nothing
** ===================================================================
*/
/* implemented as macro version. See header file. */
/*
** ===================================================================
**     Method      :  WAIT1_Waitns (component Wait)
**
**     Description :
**         Wait for a specified time in nano seconds.
**     Parameters  :
**         NAME            - DESCRIPTION
**         ns              - How many ns the function has to wait
**     Returns     : Nothing
** ===================================================================
*/
/* implemented as macro version. See header file. */
/*
** ===================================================================
**     Method      :  WAIT1_WaitOSms (component Wait)
**
**     Description :
**         If an RTOS is enabled, this routine will use a non-blocking
**         wait method. Otherwise it will do a busy/blocking wait.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
#if 0
void WAIT1_WaitOSms(void)
{
  /* Method is implemented as macro in the header file */
}
#endif

/* END WAIT1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale ColdFireV1 series of microcontrollers.
**
** ###################################################################
*/
